//   Œ蒷obt@NX
//
//  2002/ 9/10 ˁ@P

#include "windef.h"
#include "define.h"
#include "interfaces.h"
#include "classes.h"
#include <stdexcept>

using namespace std;

D2CFixedBuffer::D2CFixedBuffer() {

	setCSTRPointer(NULL);
	setBufferPointer(NULL);
	setSize(0);
	m_isAllocate=false;

	reset(256);

}

D2CFixedBuffer::D2CFixedBuffer(I32 i32Arg) {

	setCSTRPointer(NULL);
	setBufferPointer(NULL);
	setSize(0);
	m_isAllocate=false;

	if (i32Arg<1)
		return;

	reset(i32Arg);

}

D2CFixedBuffer::D2CFixedBuffer(const BUF bfArg,I32 i32Arg) {

	setCSTRPointer(NULL);
	setBufferPointer(NULL);
	setSize(0);
	m_isAllocate=false;

	if (bfArg==NULL || i32Arg<1)
		return;

	setBufferPointer(bfArg);

	setSize(i32Arg);

}

D2CFixedBuffer::D2CFixedBuffer(const D2IBufferReader *pbrArg) {

	setCSTRPointer(NULL);
	setBufferPointer(NULL);
	setSize(0);
	m_isAllocate=false;

	if (pbrArg==NULL || pbrArg->getSize()<1)
		return;

	reset(pbrArg->getSize());

	if (getBufferPointer()==NULL)
		return;

	BUF bfTmp=pbrArg->copy();

	write(0,bfTmp,getSize());

	D2Free(bfTmp);

}

D2CFixedBuffer::D2CFixedBuffer(const D2CFixedBuffer& bArg) {

	setCSTRPointer(NULL);
	setBufferPointer(NULL);
	setSize(0);
	m_isAllocate=false;

	if (bArg.getSize()<1)
		return;

	if (!reset(bArg.getSize()))
		return;

	BUF bfTmp=bArg.copy();

	write(0,bfTmp,getSize());

	D2Free(bfTmp);

}

D2CFixedBuffer& D2CFixedBuffer::operator=(const D2CFixedBuffer& bArg) {

	if (&bArg==this)
		return *this;

	setCSTRPointer(NULL);
	setBufferPointer(NULL);
	setSize(0);
	m_isAllocate=false;

	reset(bArg.getSize());

	if (getSize()<1)
		return *this;

	BUF bfTmp=bArg.copy();

	write(0,bfTmp,getSize());

	D2Free(bfTmp);

	return *this;

}

D2CFixedBuffer::~D2CFixedBuffer() {

	if (m_isAllocate && getBufferPointer()!=NULL)
		D2Free(getBufferPointer());


	if (m_bfCSTR!=NULL)
		D2Free(getCSTRPointer());

}

UI32 D2CFixedBuffer::getClassID() const { return CID_D2CFixedBuffer; }

UI32 D2CFixedBuffer::getObjectType() const {

	I32 i32ID=VER_D2_0 << 24;
	i32ID+=TYPE_BUF << 16;
	i32ID+=ENCODE_NONE;

	return i32ID;

}

UI8 D2CFixedBuffer::getObjectVersion() const { return VER_D2_0; }
UI8 D2CFixedBuffer::getDataType() const { return TYPE_BUF; }
UI16 D2CFixedBuffer::getEncoding() const { return ENCODE_NONE; }

void * D2CFixedBuffer::getInterface(UI32 u32Arg) {

	switch(u32Arg) {

	case IID_D2IObject:
		return (D2IObject *)this;

	case IID_D2IBufferReader:
		return (D2IBufferReader *)this;

	case IID_D2IBufferWriter:
		return (D2IBufferWriter *)this;

	case IID_D2IFixedBuffer:
		return (D2IFixedBuffer *)this;

	}

	return NULL;

}

CSTR D2CFixedBuffer::getCSTR() {

	if (m_bfCSTR!=NULL) {

		D2Free(m_bfCSTR);
		setCSTRPointer(NULL);

	}

	if (getSize()<1)
		return NULL;

	setCSTRPointer((BUF)D2Malloc(getSize()+1));

	if (getCSTRPointer()==NULL)
		return NULL;

	D2MemCopy(m_bfCSTR,getBufferPointer(),getSize());
	getCSTRPointer()[getSize()]=0;

	return (CSTR)getCSTRPointer();

}

I32 D2CFixedBuffer::getSize() const { return m_i32BufferSize; }

BUF D2CFixedBuffer::copy() const {

	if (getSize()<1)
		return NULL;

	BUF bfTmp=(BUF)D2Malloc(getSize());

	if (bfTmp==NULL)
		return NULL;

	D2MemCopy(bfTmp,getBufferPointer(),getSize());

	return bfTmp;

}

UI8 D2CFixedBuffer::read(I32 i32Arg) const throw(out_of_range) {

	if (i32Arg<0 || i32Arg>=getSize())
		throw out_of_range("ȃCfbNX");

	return getBufferPointer()[i32Arg];

}

I32 D2CFixedBuffer::read(I32 i32Arg1,BUF bfArg,I32 i32Arg2) const {

	if (i32Arg1<0 || i32Arg1>=getSize() || bfArg==NULL || i32Arg2<1)
		return 0;

	I32 i32Read=i32Arg2;

	if (i32Arg1+i32Read>getSize())
		i32Read=getSize()-i32Arg1;
	
	memcpy(bfArg,getBufferPointer()+i32Arg1,i32Read);

	return i32Read;

}

bool D2CFixedBuffer::equal(const BUF bfArg,I32 i32Arg) const {

	if (i32Arg!=getSize())
		return false;

	for (int i=0;i<getSize();i++)
		if (bfArg[i]!=read(i))
			return false;

	return true;

}

bool D2CFixedBuffer::equal(const D2IBufferReader *pbrArg) const {

	if (pbrArg==NULL)
		return false;

	if (pbrArg->getSize()!=getSize())
		return false;

	for (int i=0;i<getSize();i++)
		if (pbrArg->read(i)!=read(i))
			return false;

	return true;

}

bool D2CFixedBuffer::write(I32 i32Arg,UI8 u8Arg) {

	if (i32Arg<0 || i32Arg>=getSize())
		return false;

	getBufferPointer()[i32Arg]=u8Arg;

	return true;

}

I32 D2CFixedBuffer::write(I32 i32Arg1,const BUF bfArg,I32 i32Arg2) {

	if (i32Arg1<0 || i32Arg1>=getSize() || bfArg==NULL || i32Arg2<1)
		return 0;

	I32 i32Write=i32Arg2;

	if (i32Arg1+i32Write>getSize())
		i32Write=getSize()-i32Arg1;
	
	memcpy(getBufferPointer()+i32Arg1,bfArg,i32Write);

	return i32Write;

}

bool D2CFixedBuffer::fill(I32 i32Arg1,UI8 u8Arg,I32 i32Arg2) {

	if (i32Arg1<0 || i32Arg1>=getSize() || i32Arg2<1)
		return false;

	I32 i32Fill=i32Arg2;

	if (i32Arg1+i32Fill>getSize())
		i32Fill=getSize()-i32Arg1;

	FillMemory(getBufferPointer()+i32Arg1,i32Fill,u8Arg);

	return true;

}

bool D2CFixedBuffer::reset(I32 i32Arg) {

	if (i32Arg<0)
		return false;

	if (i32Arg==getSize()) {

		FillMemory(getBufferPointer(),getSize(),0);
		return true;

	}

	if (getBufferPointer()!=NULL)
		D2Free(getBufferPointer());

	setBufferPointer(NULL);

	if (i32Arg==0) {

		setSize(0);
		return true;

	}

	setBufferPointer((BUF)D2Malloc(i32Arg));

	if (getBufferPointer()==NULL) {

		setSize(0);
		return false;

	}

	m_isAllocate=true;

	setSize(i32Arg);

	return true;

}

bool D2CFixedBuffer::setSize(I32 i32Arg) {

	m_i32BufferSize=i32Arg;

	return true;

}

BUF D2CFixedBuffer::getBufferPointer() const { return m_bfBuffer; }

bool D2CFixedBuffer::setBufferPointer(BUF bfArg) {

	m_bfBuffer=bfArg;

	return true;

}

BUF D2CFixedBuffer::getCSTRPointer() const { return m_bfCSTR; }

bool D2CFixedBuffer::setCSTRPointer(BUF bfArg) {

	m_bfCSTR=bfArg;

	return true;

}
